﻿using System.Diagnostics;
using InvokeSolutions.Docx;
using System.IO;
using System.Data;
using System;
using InvokeSolutions.Docx.Data;
using System.Xml;
using System.Collections.Generic;
using System.Text.RegularExpressions;

namespace Sample0
{
    /// <summary>
    /// Sample class
    /// </summary>
    class Order
    {
        public string Name {get; set;}
        public Uri Email { get; set; }
        public string Phone { get; set; }
        public string Note { get; set; }
    }

    class Program
    {
        [STAThread]
        static void Main()
        {
            File.Copy("templates\\customers_alternate.docx", "compiled\\customers_alternate_compiled.docx", true);
            File.Copy("templates\\customers_multirow.docx", "compiled\\customers_multirow_compiled.docx", true);

            // create table data item
            TableDataItem customers = new TableDataItem();

            // add new row. each table row is DocumentDataSource entity
            customers.AddRow(DocumentDataSource.ConvertFrom(new Order { Email = new Uri("http://microsoft.net"), Name = "1", Note = "", Phone = "123" }));
            customers.AddRow(DocumentDataSource.ConvertFrom(new Order { Email = new Uri("http://two.microsoft.net"), Name = "2", Note = "", Phone = "345" }));

            customers.DetailsMethod = TableDetailsMethod.AlternateRows;

            // create data source
            DocumentDataSource dataSource = new DocumentDataSource();

            // and fill it in
            dataSource["CUSTOMERS"] = customers;


            dataSource["TOTAL_CUSTOMERS"] = 1;
            dataSource["DATE"] = DateTime.Now;

            customers.DetailsMethod = TableDetailsMethod.AlternateRows;

            // process template
            InvokeSolutions.Docx.DocumentRenderer.ProcessDocument("compiled\\customers_alternate_compiled.docx", dataSource);

            customers.DetailsMethod = TableDetailsMethod.GroupRows;

            // process template
            InvokeSolutions.Docx.DocumentRenderer.ProcessDocument("compiled\\customers_multirow_compiled.docx", dataSource);

            // run it
            Process.Start("compiled\\customers_alternate_compiled.docx");

            // run it
            Process.Start("compiled\\customers_multirow_compiled.docx");
        }
    }
}